<script setup>
    import User from "./User.vue";
    import WorkingTime from "./WorkingTime.vue";
    import ClockManager from "./ClockManager.vue";
    import Line from "./charts/line.js";
    import Doughnut from "./charts/doughnut.js";
    import Bar from "./charts/bar.js";
    import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
</script>

<template>
    <div class="back">
      <br/>
      <h1 class="text">
        <font-awesome-icon icon="fa-solid fa-business-time" /> TiRe
      </h1>
      <nav>
        <nav class="navbar navbar-light d-flex justify-content-around">
            <h2 class="text"> Bonjour {{ username }}</h2>
            <div>
              <b-dropdown id="dropdown-1" text="Information" class="m-md-2 color">
                <router-link :to="{name: 'Profil'}"><b-dropdown-item><font-awesome-icon icon="fa-solid fa-user" /> Profil</b-dropdown-item></router-link>
                <router-link :to="{name: 'Times'}"><b-dropdown-item><font-awesome-icon icon="fa-solid fa-hourglass-half" /> WorkingTime</b-dropdown-item></router-link>
                <b-dropdown-item @click="signOut"><font-awesome-icon icon="fa-solid fa-arrow-right-from-bracket" /> Sign out</b-dropdown-item>
              </b-dropdown>
            </div>
        </nav>
      </nav>
      <ClockManager @updateCharts="updateAllCharts" /><br />
      <div class="container">
        <div class="row justify-content-around">
          <div class="col-12 col-md-4">
            <div class="card border-secondary mb-3" style="max-width: 40rem">
              <div class="card-header">Time worked per day</div>
              <div class="card-body text-secondary">
                <Line :chart-data="hourData" />
              </div>
            </div>
          </div>
          <div class="col-12 col-md-4">
            <div class="card border-secondary mb-3" style="max-width: 40rem">
              <div class="card-header">Minimum time per week</div>
              <div class="card-body text-secondary">
                <Doughnut :chart-data="weekMinData" />
              </div>
            </div>
          </div>
        </div>
        <div class="row justify-content-around">
          <div class="col-12 col-md-4">
            <div class="card border-secondary mb-3" style="max-width: 40rem">
              <div class="card-header">After hours</div>
              <div class="card-body text-secondary">
                <Bar :chart-data="afterHoursData" />
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    </template>



<script>
export default {
  name: "Time Manager",
  components: {
    User,
    WorkingTime,
    ClockManager,
  },
  data() {
    return {
      user: {
        id: "",
        token: "",
        role: ""
      },
      username: "",
      email: "marvin@epitech.eu",
      newname: "",
      newemail: "",
      newstrat: "",
      newend: "",
      newuser: "",
      revele: false,
      hourData: {
        labels: ['Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday', 'Sunday'],
        datasets: [
          {
            label: 'Time worked',
            backgroundColor: '#f87979',
            data: [0, 0, 0, 0, 0, 0, 0]
          }
        ]
      },
      weekMinData: {
        labels: ['Done', 'Todo'],
        datasets: [
          {
            backgroundColor: ['#41B883', '#E46651'],
            data: [0, 35]
          }
        ]
      },
      afterHoursData: {
        labels: [
          'Monday',
          'Tuesday',
          'Wednesday',
          'Thursday',
          'Friday',
          'Saturday',
          'Sunday'
        ],
        datasets: [
          {
            label: 'Normal hours',
            backgroundColor: '#79f879',
            data: [0, 0, 0, 0, 0, 0, 0],
            stack: 'Stack 0',
          },
          {
            label: 'After hours',
            backgroundColor: '#f87979',
            data: [0, 0, 0, 0, 0, 0, 0],
            stack: 'Stack 0',
          },
        ]
      }
    };
  },
  methods: {
    async fetchWorkingTimes() {
      const url = 'http://localhost:4000/api/workingtimes/' + this.user.id
      let result = await (await fetch(url, {
          method: 'GET',
          headers: {
              'Accept': 'application/json',
              'Content-Type': 'application/json',
              'Authorization': `Bearer ${this.user.token}`
          },
      })).json()
      return result.data
    },
    getPrevMonday() {
      let prevMonday = new Date()
      prevMonday.setDate(prevMonday.getDate() - (prevMonday.getDay() + 6) % 7)
      prevMonday.setHours(0)
      prevMonday.setMinutes(0)
      prevMonday.setSeconds(0)
      prevMonday.setMilliseconds(0)

      return prevMonday
    },
    //graph Line
    async getWeekWork() {
      let prevMonday = this.getPrevMonday()
      let times = await this.fetchWorkingTimes()
      for (let dayOfWeek = 0; dayOfWeek < 7; dayOfWeek++) {
        this.hourData.datasets[0].data[dayOfWeek] = 0
      }
      times.forEach(oneDay => {
        let startDate = new Date(oneDay.start)
        let endDate = new Date(oneDay.end)

        if (startDate >= prevMonday) {
          let hours = parseInt((endDate - startDate) / 1000 / 3600)
          let dayOfWeek = startDate.getDay() - 1
          if (dayOfWeek == -1)
            dayOfWeek = 6;
          this.hourData.datasets[0].data[dayOfWeek] += hours
        }
      });
    },
    // graph Doughnut
    async getSumWeekWork() {
      let prevMonday = this.getPrevMonday()
      let times = await this.fetchWorkingTimes()
      let sum = 0
      times.forEach(oneDay => {
        let startDate = new Date(oneDay.start)
        let endDate = new Date(oneDay.end)

        if (startDate >= prevMonday) {
          let hours = parseInt((endDate - startDate) / 1000 / 3600)
          sum += hours
        }
      });
      this.weekMinData.datasets[0].data[0] = sum
      this.weekMinData.datasets[0].data[1] = Math.max(0, 35 - sum)
    },
    //graph Bar
    async getWeekAfterHours() {
      let prevMonday = this.getPrevMonday()
      let times = await this.fetchWorkingTimes()
      for (let dayOfWeek = 0; dayOfWeek < 7; dayOfWeek++) {
        this.afterHoursData.datasets[0].data[dayOfWeek] = 0
        this.afterHoursData.datasets[1].data[dayOfWeek] = 0
      }
      times.forEach(oneDay => {
        let startDate = new Date(oneDay.start)
        let endDate = new Date(oneDay.end)

        if (startDate >= prevMonday) {
          let hours = parseInt((endDate - startDate) / 1000 / 3600)
          let dayOfWeek = startDate.getDay() - 1
          if (dayOfWeek == -1)
            dayOfWeek = 6;
            let normal = this.afterHoursData.datasets[0].data[dayOfWeek]
            if (dayOfWeek < 5) {
              this.afterHoursData.datasets[0].data[dayOfWeek] = Math.min(7, hours + normal)
              this.afterHoursData.datasets[1].data[dayOfWeek] = Math.max(0, hours + normal - 7)
            }
            else {
              this.afterHoursData.datasets[1].data[dayOfWeek] += hours
            }
        }
      });
    },
    async signOut() {
      const response = await fetch('http://localhost:4000/auth/sign_out', {
        method: "POST",
          headers: {
          Accept: "application/json",
          "Content-type": "application/json",
        }
      });
      if (response.status == 204) {
        localStorage.clear()
        this.$router.push('/login');
      }
    },
    async updateAllCharts() {
      this.getWeekWork()
      this.getSumWeekWork()
      this.getWeekAfterHours()
    },
    async getUser() {
      const url = "http://localhost:4000/api/users/" + this.user.id;
      let result = await (
        await fetch(url, {
          method: "GET",
          headers: {
            Accept: "application/json",
            "Content-Type": "application/json",
            'Authorization': `Bearer ${this.user.token}`
          },
        })
      ).json();
      this.username = result.data.username
    },
  },
  mounted() {
    if (!localStorage.getItem("token")) { // si pas connecte
      this.$router.push('/login');
    }
    else {
      this.user.id = localStorage.getItem('id')
      this.user.token = localStorage.getItem('token')
    }
    this.getUser()
    this.updateAllCharts()
  },
  computed: {
    toggleModale: function() {
      this.revele = !this.revele;
    }
  },
};
</script>

<style>
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
}

nav {
  padding: 30px;
}

nav a {
  font-weight: bold;
  color: #2c3e50;
}

nav a.router-link-exact-active {
  color: #42b983;
}

.back {
    background-image: linear-gradient(to top, #0d3888 0%, #14326a 1%, #0d3477 100%);
    height: 100%;
}

.text {
  color: aliceblue;
}
.color{
    background-image: linear-gradient(120deg, #a1c4fd 0%, #c2e9fb 100%)!important;
}
</style>